/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// グループ比較集計結果フレーム用アクション・クラス
//
//
//	変更履歴
//	2004.01.08 新規作成		A.Shimoma
//
package jp.co.ntt.lms.xms.logsumup;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.StringTokenizer;

import javax.servlet.http.HttpServletRequest;
import jp.co.ntt.lms.xmo.util.ChangeEncode;
import jp.co.ntt.lms.xmo.util.XMODate;
import jp.co.ntt.lms.xms.framework.Constant;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsScreenBean;
import jp.co.ntt.lms.xms.framework.base.AbstractRmiAction;
import jp.co.ntt.lms.xms.framework.base.ActionResultBean;
import jp.co.ntt.lms.xms.framework.base.Logic;

/**
 * ログ集計グループ比較結果フレーム出力用アクション・クラス。<br>
 * 
 * @author shimoma
 */
public class LoLogGroupCompareAction extends AbstractRmiAction {

	/**
	 * リスエストされた基本グループID
	 */
	private String baseGroupId;
	/**
	 * リスエストされた基本グループ名
	 */
	private String baseGroupName;
	/**
	 * リスエストされた基本グループ外部ID
	 */
	private String baseGroupForeignId;
	/**
	 * リスエストされたグループIDリスト
	 */
	private List chkGroupList = new ArrayList();
	/**
	 * リクエストされた基本LoID
	 */
	private String LoID;
	/**
	 * リスエストされた基本LO名
	 */
	private String LoName;
	/**
	 * リスエストされた基本LO外部ID
	 */
	private String LoForeignId;
	/**
	 * リスエストされた基本リアルLOID
	 */
	private String realLoID;
	/**
	 * リスエストされた基本グループ配下のユーザ数
	 */
	private String userCount;

	/**
	 * ロジッククラス配列を戻す。<br>
	 * @param request リクエストオブジェクト。
	 * @return LoLogGroupCompareLogicクラスオブジェクト１要素だけの配列。
	 * @see LoLogGroupCompareLogic
	 */
	protected Logic[] getLogics(XmsRequest request) throws XmsException {

		Logic[] logSumUps = null;
		logSumUps = new Logic[1];
		// Logicクラスの派生クラスを生成
		logSumUps[0] =
			new LoLogGroupCompareLogic(
				chkGroupList,
				LoID,
				baseGroupId,
				realLoID);

		return logSumUps;

	}

	/**
	 * リクエスト初期化処理。<br>
	 * パラメータ名称&quot;userid&quot;、&quot;loid&quot;で送信された
	 * リクエストパラメータをリスト化して、内部で保持する。
	 * 
	 * @param xmsRequest   HTTPリスエスト
	 * @param xmsResponse  HTTPレスポンス
	 * @see jp.co.ntt.lms.xms.framework.base.AbstractRmiAction#initProsessRequest(XmsRequest)
	 */
	public void initProcessRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {
		// スーパークラスのメソッドを呼び出し。
		super.initProcessRequest(xmsRequest, xmsResponse);

		HttpServletRequest request = null;

		request = xmsRequest.getRequest();

		// 基本グループIDをパラメータより取得
		baseGroupId = ChangeEncode.setHttpChar(request.getParameter("baseGroupId"));
		// 基本グループ名をパラメータより取得
		baseGroupName =
			ChangeEncode.setHttpChar(request.getParameter("baseGroupName"));
		// 基本グループ外部IDをパラメータより取得
		baseGroupForeignId =
			ChangeEncode.setHttpChar(request.getParameter("baseGroupForeignId"));

		// LoIDをパラメータより取得
		LoID = ChangeEncode.setHttpChar(request.getParameter("LoID"));
		// 基本LO名をパラメータより取得
		LoName = ChangeEncode.setHttpChar(request.getParameter("LoName"));
		// 基本外部LOIDをパラメータより取得
		LoForeignId = ChangeEncode.setHttpChar(request.getParameter("LoForeignId"));
		// 基本リアルLOIDをパラメータより取得
		realLoID = ChangeEncode.setHttpChar(request.getParameter("realLoID"));

		// 基本グループ配下のユーザ数をパラメータより取得
		userCount = ChangeEncode.setHttpChar(request.getParameter("userCount"));

		// 選択されたグループＩＤをパラメータより取得
		String paramGroup = ChangeEncode.setHttpChar(request.getParameter("group"));

		// パラメータチェック
		if (baseGroupId.equals("")
			|| baseGroupName.equals("")
			|| LoID.equals("")
			|| LoName.equals("")
			|| userCount.equals("")
			|| paramGroup.equals("")) {
			throw new XmsInnerException("parameter is null.");
		}

		// グループＩＤのパラメータを ｢,｣ 毎に分割
		StringTokenizer tokenizer = new StringTokenizer(paramGroup, ",");
		while (tokenizer.hasMoreTokens()) {
			chkGroupList.add(tokenizer.nextToken());
		}

	}

	/**
	 * 検索結果をＣＳＶ文字列に変換する。<br>
	 * このクラスでは空文字列（&quot;&quot;）を戻すように定義する。
	 * サブクラスにて適宜修正する。
	 * このメソッドは渡されるbeanがActionResultBeanであり、
	 * 内部にLoLogGroupCompareResultを保持していることを期待しています。
	 * 
	 * @param bean アクション実行結果オブジェクト。
	 * @return beanの中からLoLogGroupCompareResultを取得し、CSVに変換した文字列。
	 * @see ActionResultBean
	 * @see LoLogGroupCompareResult
	 * @throws 渡されたbeanが不正などCSV変換に問題が発生した場合。
	 */
	public String convertToCSV(XmsScreenBean bean) {

		// 戻り値
		String retVal = null;
		// 戻り値作成用バッファ
		StringBuffer buffer = null;

		ActionResultBean resultBean = null;
		// グループログ集計結果専用クラス
		LoLogGroupCompareResult logResult = null;

		try {
			buffer = new StringBuffer();
			resultBean = (ActionResultBean) bean;
			// 先頭要素となっているロジック結果を取得
			logResult =
				(LoLogGroupCompareResult) resultBean.getFirstLogResult();

			// =================================================================
			// レポート部
			// #レポート
			buffer.append(LoLogConstant.STR_REPORT_o + ":");
			// 学習状況(グループ一覧)
			buffer.append(LoLogConstant.WIN_TITLE_GROUP_COMPARE_STATUS_o);
			buffer.append(",");
			// ＬＯ
			buffer.append(LoLogConstant.STR_LO_o + ":");
			// LO名
			buffer.append(LoName);
			// LO外部ID
			buffer.append("(" + LoForeignId + ")");
			buffer.append(",");
			// グループ
			buffer.append(LoLogConstant.STR_GROUP_o + ":");
			// グループ名
			buffer.append(baseGroupName);
			// グループ外部ID
			buffer.append("(" + baseGroupForeignId + ")");
			buffer.append(",");
			// 集計対象者数
			buffer.append(LoLogConstant.STR_CANDIDATE_TOTAL_COUNT_o + ":");
			// 配下のユーザ
			buffer.append(LoLogConstant.STR_SUBORDINATE_USER);
			// 人数
			buffer.append(userCount);
			// 人
			buffer.append(LoLogConstant.STR_USER_UNIT_o);

			// 行区切り文字
			buffer.append(Constant.LINE_SEPARATOR);

			// 個別ヘッダ部
			// グループ名
			buffer.append(LoLogConstant.STR_GROUP_NAME_o);
			buffer.append(",");
			// 外部ID
			buffer.append(LoLogConstant.STR_FOREIGN_ID_o);
			buffer.append(",");
			// 学習開始日時
			buffer.append(LoLogConstant.STR_DATE_START_o);
			buffer.append(",");
			// 最終アクセス日時
			buffer.append(LoLogConstant.STR_DATE_LAST_o);
			buffer.append(",");
			// 総アクセス回数
			buffer.append(LoLogConstant.STR_TOTAL_ACCESS_o);
			buffer.append(",");
			// 累積滞在時間
			buffer.append(LoLogConstant.STR_TOTAL_LEARN_TIME_o);
			buffer.append(",");
			// 完了率
			buffer.append(LoLogConstant.STR_USER_COMPLETE_o);
			buffer.append(",");
			// 合格率
			buffer.append(LoLogConstant.STR_USER_PASS_o);
			// 行区切り文字
			buffer.append(Constant.LINE_SEPARATOR);

			// =================================================================
			// データ部
			logResult.beforeFirst();

			Date startDate = null;
			Date endDate = null;

			String strStartDate = null;
			String strEndDate = null;
			String strAccessCount = null;
			String strResidanceTime = null;
			String strUserComplete = null;
			String strUserPass = null;
			String strUserCount = null;
			String strCompPercent = null;
			String strPassPercent = null;
			String strGroupPath = null;

			List startDateList = logResult.getStartDateList();
			List endDateList = logResult.getEndDateList();
			List accessCountList = logResult.getAccessCountList();
			List residanceTimeList = logResult.getResidanceTimeList();

			List userCompleteList = logResult.getUserCompleteList();
			List userPassList = logResult.getUserPassList();
			List userCountList = logResult.getUserCountList();
			List compPercentList = logResult.getCompPercentList();
			List passPercentList = logResult.getPassPercentList();
			List groupPathList = logResult.getGroupPathList();

			HashMap hmGroupForeignId = logResult.getHmGroupForeignId();

			// グループ外部ID順にソートされた順序で出力を行います。
			while (logResult.next()) {

				// ソートされたグループIDを取得
				String sortGroupId =
					logResult.getSortGroupIdList();
				// 取得したグループIDの元の順序を取得
				// その順序を元に格納されている各データを取得しています。
				int number =
					Integer.parseInt(
				(String) hmGroupForeignId.get(sortGroupId));

				// ソートされたグループ外部IDを取得
				String sortGroupForeignId = logResult.getSortGroupForeignIdList();

				// 学習開始日時
				startDate = (Date) startDateList.get(number);
				if (startDate == null) {
					strStartDate = "";
				} else {
					// 日付型データをyyyy/mm/dd HH:mm:ss型に変換
					strStartDate = XMODate.parseTime(startDate);
				}
				// 学習終了日時
				endDate = (Date) endDateList.get(number);
				if (endDate == null) {
					strEndDate = "";
				} else {
					// 日付型データをyyyy/mm/dd HH:mm:ss型に変換
					strEndDate = XMODate.parseTime(endDate);
				}
				// 総アクセス回数
				if (accessCountList.get(number) == null) {
					strAccessCount = "";
				} else {
					strAccessCount = (String) accessCountList.get(number);
				}

				// 累積滞在時間
				if (residanceTimeList.get(number) == null) {
					strResidanceTime = "";
				} else {
					strResidanceTime = (String) residanceTimeList.get(number);
				}

				// 完了者数
				strUserComplete = (String) userCompleteList.get(number);
				// 合格者数
				strUserPass = (String) userPassList.get(number);
				// ユーザ数
				strUserCount = (String) userCountList.get(number);
				// 完了率
				strCompPercent = (String) compPercentList.get(number);
				// 合格率
				strPassPercent = (String) passPercentList.get(number);
				// グループパス
				strGroupPath = (String) groupPathList.get(number);

				buffer.append(strGroupPath);
				buffer.append(",");
				buffer.append(sortGroupForeignId);
				buffer.append(",");
				buffer.append(strStartDate);
				buffer.append(",");
				buffer.append(strEndDate);
				buffer.append(",");
				buffer.append(strAccessCount);
				buffer.append(",");
				buffer.append(strResidanceTime);
				buffer.append(",");
				buffer.append(strUserComplete);
				buffer.append("/" + strUserCount);
				buffer.append("(" + strCompPercent + "%)");
				buffer.append(",");
				buffer.append(strUserPass);
				buffer.append("/" + strUserCount);
				buffer.append("(" + strPassPercent + "%)");

				buffer.append(Constant.LINE_SEPARATOR);

			}
			// カーソルを先頭行の直前の行に移動する。
			logResult.beforeFirst();

			// 取得したBufferを文字列に変換
			retVal = buffer.toString();

		} catch (Exception e) {
			e.printStackTrace();
			retVal = "";
		}

		return retVal;
	}

}
